function doTest() {
  this.promptService.alert(null,'Test', 'doTest');
}

function initialize() {
  var app = Components.classes["@mozilla.org/xre/app-info;1"].
         getService(Components.interfaces.nsIXULAppInfo);
/*
  if (app.name=='Thunderbird' || app.name=='Mozilla-Thunderbird') //TB uses 'Thunderbird', icedove uses 'Mozilla-Thunderbird' :-(
    this.mTB3=app.version.substr(0,1)!='3'?0:app.version.substr(2,3)=='0a1'?1:
        app.version.substr(2,2)=='0a'||app.version.substr(2,3)=='0b1'?2:3;  //3: 3.0b2
  else if (app.name=='SeaMonkey')
    this.mTB3=app.version.substr(2,3)=='0a1'||app.version.substr(2,3)=='0a2'?2:3;
*/
  this.mAppStarttime = Math.round(Date.now()/1000);
  var em = Components.classes["@mozilla.org/extensions/manager;1"].
    getService(Components.interfaces.nsIExtensionManager);
  var item = em.getItemForID("addressbookssync@ggbs.de"); //nsIUpdateItem
  this.mVersion=item.version;
  this.mPrefBranch.setCharPref('version',item.version);

  this.mNoDirProp=Components.classes["@mozilla.org/addressbook/properties;1"]?false:true;     //since TB3a
  this.mHaveABManager=Components.classes["@mozilla.org/abmanager;1"]?true:false; //since TB3a: nsIAbManager; else nsIAddrBookSession

dump('AddressbooksSynchronizer '+this.mVersion+' appName='+app.name+' appVersion='+app.version+
        '\n   noDirProp='+this.mNoDirProp+' haveABManager='+this.mHaveABManager+'\n');

  this.update();  //Falls was zu updaten ist
  this.cleanup(); //preferences cleanup
  var console = Components.classes["@mozilla.org/consoleservice;1"]
                .getService(Components.interfaces.nsIConsoleService);
  console.logStringMessage('AddressbooksSynchronizer '+this.mVersion+
    ' appName='+app.name+' appVersion='+app.version+'\n');

  try { this.mNT = this.mPrefBranch.getBoolPref("NT"); } catch(e) { this.mNT = false; }
  if (this.mNT) {
    var observerService =
      Components.classes["@mozilla.org/observer-service;1"]
        .getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(this,"quit-application",false);
    observerService.addObserver(this,"domwindowopened",false);
    observerService.addObserver(this,"domwindowclosed",false);
  }
}

function update() {

//// < 0.8.3  : Preferences aus globalem ldap_2.servers.xxx in unseren Bereich verschieben
  var count=new Object();
  var prefs=new Object();
  this.mPrefBranch.getChildList ( "ldap_2.servers", count , prefs );
  if (!count.value) {
//this.promptService.alert(null,'update', 'must update: count='+count.value);

    // get all MAB Files
    var mabs=new Object();
    var cn = this.directory.childNodes;
    while( cn.hasMoreElements() )
    {
      var dir = cn.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
      var dirProp = this.noDirProp?dir:dir.directoryProperties;
      var dirType = dirProp.dirType;
      if (dirType==kPABDirectory) {            // ignore ldap-addressbooks (dirType!=2)
        var prefName = this.noDirProp?dirProp.dirPrefId:dirProp.prefName;
        if (mabs[prefName])
          dump('nsIAbDirectory::childNodes returned double addressbook '+dirProp.fileName+'('+file+')\n');
//          this.promptService.alert(null,'update', 'nsIAbDirectory::childNodes returned double addressbook '+dirProp.fileName);
        else {
//          this.promptService.alert(null,'update', 'move '+dirProp.fileName);
          mabs[prefName]=dirProp;
          if (this.separateupdown) {
            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync.up" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.up', sync);

            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync.down" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.down', sync);
          } else {
            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.up', sync);
            this.mPrefBranch.setBoolPref(prefName+'.down', sync);
          }
          try { sync = this.mGlobalPref.deleteBranch( prefName+".extensions.addressbookssync" ); }
            catch(e) { this.promptService.alert(null,'update', e); }
        }
      }
    } // while
    this.mGlobalPref.savePrefFile(null);  //save to prefs.js
  }
//else this.promptService.alert(null,'update', 'not updating');
//// Ende < 0.8.3

//// <= 0.8.4  : timedupload incorrectly stored as int
  try {
    var val=this.mPrefBranch.getIntPref("timedupload");
    // if this succeeds, we have to update
    this.mPrefBranch.deleteBranch("timedupload");
    this.mPrefBranch.setBoolPref("timedupload", val!=0);
    this.mGlobalPref.savePrefFile(null);  //save to prefs.js
  } catch(e) {  }
//// Ende <= 0.8.4

}

/*
 *  cleanup preferences
 */
function cleanup() {
  count=new Object();
  var prefs=this.mGlobalPref.getChildList("ldap_2.servers", count);
  var done=new Object();
  done['ldap_2.servers.default']=1;
  for (var i=0; i<count.value; i++) {
    var pref=prefs[i];
    pref=pref.replace(/(ldap_2.servers.[^.]+)\..+/,'$1');
    if (done[pref]) continue;
    done[pref]=1;
    try {
      this.mGlobalPref.getCharPref(pref+'.description');  //!!!!
    } catch(e) {
//this.promptService.alert(null, 'test', pref);
      try { sync = this.mGlobalPref.deleteBranch(pref); }
        catch(e) { this.promptService.alert(null,'update', e); }
    }
  }

  var prefs=this.mPrefBranch.getChildList("ldap_2.servers", count);
    //liefert _ALLE_keys
  for (var i=0; i<count.value; i++) {
    var pref=prefs[i];
    pref=pref.replace(/\.[^.]+$/,'');
    try {
      this.mGlobalPref.getCharPref(pref+'.description');
    } catch(e) {
      try { sync = this.mPrefBranch.deleteBranch(pref); }
        catch(e) { this.promptService.alert(null,'update', e); }
    }
  }

  this.mGlobalPref.savePrefFile(null);  //save to prefs.js

}

/*
 * returns list of mab to be synced
 */
function syncedAddressbooks(direction, singleBook)
{   //direction: up, down, all
  var mabs=new Object();
  var mabsArray=Components.classes["@mozilla.org/supports-array;1"]
         .createInstance(Components.interfaces.nsICollection);

  var cn = this.directory.childNodes;
  var found=false;
  while( cn.hasMoreElements() )
  {
    var dir = cn.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
    var dirProp = this.noDirProp?dir:dir.directoryProperties;
    if (dirProp.dirType==kPABDirectory) {            // ignore ldap-addressbooks (dirType!=2)
      var sync=false;
      if (direction=='all')
        sync=true
      else if (singleBook && dirProp.fileName==singleBook)
        sync=true;
      else if (!singleBook) {
        var prefName = this.noDirProp?dirProp.dirPrefId:dirProp.prefName;
        try { sync = this.mPrefBranch.getBoolPref(prefName+'.'+direction); }
          catch(e) { sync=false; }
      }
      if (sync) {
        found=true;
        var file = dirProp.fileName;
        if (mabs[file])
          // this ist a problem with the preferences, defining a book more than once!
          dump('nsIAbDirectory::childNodes returned double addressbook '+dirProp.fileName+'('+file+')\n');
        else {
          mabs[file]=true;
          mabsArray.AppendElement(dir);
        }
      }
    }
  } // while
  if (!found && direction=='down' && singleBook) { //its a new addressbook
    var sb=Components.classes["@mozilla.org/supports-string;1"]
        .createInstance(Components.interfaces.nsISupportsString);
    sb.data=singleBook;
    mabsArray.AppendElement(sb);
  }
  return mabsArray;
}

/*
 * return address book data structure associated with filename or description (=address book name)
 * TODO: might fail, if called with a mabName and the mabName is in a foreign language!
 *        (see mails with Ivan Kolchagov, to reproduce: change personal address book to bulgarien name)
 */
function getAddressBook( name )
{
  var cn = this.directory.childNodes;
  while( cn.hasMoreElements() )
  {
    var dir = cn.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
    var dirProp = this.noDirProp?dir:dir.directoryProperties;
    var description=dir.dirName;
    if( dirProp.fileName == name || description == name) {
        return dir;
    }
  } // while
  return null;
} // getAddressBook

/*
 * create new address book
 */
function createAddressBook(name, fileName)
{
  if (this.noDirProp) { //since TB3a
    var uri=kMDBDirectoryRoot+fileName;
    try {
dump(name+' created from '+uri+'\n');
      this.directory.createDirectoryByURI(name, uri);
    } catch (e) {
      this.promptService.alert(null, 'ERROR TB3', 'createAddressBook('+name+','+fileName+')\n'+e);
      return null;
    }
  } else {
dump(name+' created from '+fileName+'\n');
    var abProps = Components.classes["@mozilla.org/addressbook/properties;1"].
      createInstance(Components.interfaces.nsIAbDirectoryProperties);
    abProps.description = name;
    abProps.dirType = kPABDirectory;
    abProps.fileName = fileName;
//    this.directory.createNewDirectory( abProps );
    try {
      Components.classes["@mozilla.org/addressbook;1"].
        getService(Components.interfaces.nsIAddressBook).
        newAddressBook(abProps);
    } catch(e) {  // might throw NS_ERROR_FILE_ACCESS_DENIED
      this.promptService.alert(null, 'ERROR TB2', 'createAddressBook('+name+','+fileName+')\n'+e);
      return null;
    }
  }
  var dir=this.getAddressBook(fileName);
  dir.lastModifiedDate=this.mAppStarttime; //set to 'not modified'
  return dir;
} // createAddressBook

/*
 * delete an address book
 */
function deleteAddressBook(dir)
{
  // Move focus away from the to be deleted addressbook
    // this has to be done in the AddressBook window :-((
//  try {  SetAbView(kPersonalAddressbookURI, false);} catch(e) {   this.promptService.alert(null,'ERROR', e);}

//  dir=dir.QueryInterface(Components.interfaces.nsIAbDirectory);
  try {
    var dirProp = this.noDirProp?dir:dir.directoryProperties;
    var prefName = this.noDirProp?dirProp.dirPrefId:dirProp.prefName;
    var URI=dirProp.URI;
    if (URI==kPersonalAddressbookURI ||
        URI==kCollectedAddressbookURI)
      return false;

    if (!Components.classes["@mozilla.org/addressbook;1"]) {  //since TB3a
dump('deleting '+URI+'\n');
      this.directory.deleteDirectory(dir);
    } else {
dump('deleting '+URI+' (TB2 version)\n');
      // It seems to be necessary to
      // delete the maillists before deleting the directory
      var lists=dir.childNodes;
      while( lists.hasMoreElements() ) {
        var list = lists.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
        dir.deleteDirectory(list);
      }
      lists=null;

      var ab = Components.classes["@mozilla.org/addressbook;1"].
                        getService(Components.interfaces.nsIAddressBook);
      var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                        getService(Components.interfaces.nsIRDFService);
      var parentArray = Components.classes["@mozilla.org/supports-array;1"].
                        createInstance(Components.interfaces.nsISupportsArray);
        var parentDir = RDF.GetResource("moz-abdirectory://").
                        QueryInterface(Components.interfaces.nsIAbDirectory);
        parentArray.AppendElement(parentDir);
      var resourceArray = Components.classes["@mozilla.org/supports-array;1"].
                        createInstance(Components.interfaces.nsISupportsArray);
        var selectedABResource = dir.
                        QueryInterface(Components.interfaces.nsIRDFResource);
        resourceArray.AppendElement(selectedABResource);
      var addressbookDS = RDF.GetDataSource("rdf:addressdirectory");
      ab.deleteAddressBooks(addressbookDS, parentArray, resourceArray);
    }
      //prefName='ldap_2.servers.name' mit name='history', 'pab' oder eigener
    this.mGlobalPref.clearUserPref( prefName+'.position' );  // sometimes remains!?
    this.mGlobalPref.deleteBranch( prefName );

    return true;
  } catch (e) {
this.promptService.alert(null, 'ERROR', 'deleteAddressBook('+dir.dirName+')\n'+e);
    return false;
  }
} // deleteAddressBook

/*
 * remove Listeners from addressbook
 */
function removeListeners(dir) {
// remove listeners
try {
  var curDB;
  if (this.haveABManager) {
    var manager=Components.classes["@mozilla.org/abmanager;1"]
      .getService(Components.interfaces.nsIAbManager);
    var directory = manager.getDirectory(dir.URI);

    var MDB=directory.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
    // MDB.database und MDB.databaseFile sind noch undefined
//dump('MDB: '+MDB+' '+MDB.database+' '+MDB.databaseFile+'\n');
    curDB=MDB.database; //nsIAddrDatabase
  } else {
    var ab = Components.classes["@mozilla.org/addressbook;1"].
      getService(Components.interfaces.nsIAddressBook);
    var dirProp = this.noDirProp?dir:dir.directoryProperties;
//Postbox has no getAbDatabaseFromURI()
    if (ab.getAbDatabaseFromURI)
      curDB=ab.getAbDatabaseFromURI(dirProp.URI); //nsIAddrDatabase
    else {  //Postbox (1.0b13), but should run in TB2 as well
dump('Postbox: no getAbDatabaseFromURI\n');
      var file=dirProp.URI.replace(/.*\/\//,'');
      //var path=getDir('ProfD');
      var ds = Components.classes['@mozilla.org/file/directory_service;1']
                .getService(Components.interfaces.nsIProperties);
      var path = ds.get('ProfD',  Components.interfaces.nsIFile)
                  .QueryInterface(Components.interfaces.nsILocalFile);
      path.appendRelativePath(file);
      var db=Components.classes["@mozilla.org/addressbook/carddatabase;1"].
        getService(Components.interfaces.nsIAddrDatabase);
      curDB=db.open(path, false/*don't create*/, true);
    }
  }
//dump('curDB '+curDB+'\n');  //dont use in TB2: curDB.dbPath

  var mailLists=dir.addressLists;
  if (!mailLists.Count) {  // since TB3a2: nsIMutableArray (which has .length, not .Count())
    var count=mailLists.length;
    for (var i=0; i<count; i++) {
      var list=mailLists.queryElementAt (i, Components.interfaces.nsIAddrDBListener);
      try { curDB.removeListener(list); }
      catch(e) { } //exception, wenn kein listener existiert
    }
  } else {                        // nsISupportsArray
    var count=mailLists.Count();
    for (var i=0; i<count; i++) {
      var list = mailLists.GetElementAt(i).QueryInterface(Components.interfaces.nsIAddrDBListener);
      try { curDB.removeListener(list); }
      catch(e) { } //exception, wenn kein listener existiert
    }
  }
} catch(e) {
dump('removeListeners: '+e+'\n');
}
  try { curDB.removeListener(dir.QueryInterface(Components.interfaces.nsIAddrDBListener)); }
  catch(e) { /*dump('curDB.rem '+e+'\n');*/ } //exception, wenn kein listener existiert
//dump(count+' listeners removed\n');
  return curDB;
}

/*
 * clear an address book
 */
function clearAddressBook(dir)
{
  function deleteLists(ab) {
dump('  delete Lists\n');
    var mdb=ab.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
    var lists=ab.addressLists;
//dump('v');
    if (!lists.Count) {  // since TB3a2: nsIMutableArray (which has .length, not .Count()) {
      var count=lists.length;
      for (var i=count-1; i>=0; i--){ //backwards!
        try {
          var list=lists.queryElementAt(i, Components.interfaces.nsIAbCard);
          var card=list.QueryInterface(Components.interfaces.nsIAbCard);
//dump('  card '+card.primaryEmail+'\n');
//dump('.');
          mdb.removeEmailAddressAt(i);
        } catch(e) {
          var list=lists.queryElementAt(i, Components.interfaces.nsIAbDirectory);
          deleteLists(list);
          list=list.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
          //noscript: list.removeElementsFromAddressList()
//dump('+');
          ab.deleteDirectory(list);
        }
      }
    } else {
      var count=lists.Count();
//dump('--addresslists has '+count+' entries\n');
      for (var i=count-1; i>=0; i--){ //backwards!
        var list=lists.GetElementAt(i);
        if (list instanceof Components.interfaces.nsIAbCard) {
          var card=list.QueryInterface(Components.interfaces.nsIAbCard);
//dump('  card '+card.primaryEmail+'\n');
//dump('.');
          mdb.removeEmailAddressAt(i);
        } else {
          list=list.QueryInterface(Components.interfaces.nsIAbDirectory);
//dump('  list '+list.dirName+'\n');
          deleteLists(list);
          list=list.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
          //noscript: list.removeElementsFromAddressList()
//dump('+');
          ab.deleteDirectory(list);
        }
      }
    }

//dump('^');
  }

  function collectCardsToDelete(ab, use_sa) {
dump('  collect cards to delete\n');
    var cardsE=ab.childCards;
    var cards;
    if (cardsE.hasMoreElements) { // since TB3a
      // cardsE is a nsISimpleEnumerator
      if (!use_sa) { //this is the normal case with TB
        cards = Components.classes["@mozilla.org/array;1"].
          createInstance(Components.interfaces.nsIMutableArray);
        while( cardsE.hasMoreElements() ) {
  //dump('save card '+card.primaryEmail+'\n');
  //dump('.');
          cards.appendElement(cardsE.getNext(), false);
        }
        cards=cards.QueryInterface(Components.interfaces.nsIArray);
      } else { //Postbox wants a nsISupportsArray
        cards = Components.classes["@mozilla.org/supports-array;1"].
          createInstance(Components.interfaces.nsISupportsArray);
        while( cardsE.hasMoreElements() ) {
  //dump('save card '+card.primaryEmail+'\n');
  //dump('.');
          cards.AppendElement(cardsE.getNext());
        }
      }
    } else {
      // cardsE is a nsIEnumerator
      cards = Components.classes["@mozilla.org/supports-array;1"].
        createInstance(Components.interfaces.nsISupportsArray);
        //convert nsIEnumerator to nsISupportsArray (don't try dir.dropCard()!)
      var goon=1;
        // Loop over the cards
      try { cardsE.first() } catch (e) { goon=0; }
      while (goon) {
        var card = cardsE.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
//dump('save card '+card.primaryEmail+'\n');
//dump('.');
        cards.AppendElement(card);
        try { cardsE.next() } catch(e) { goon=0; }
      }
//var count=cards.Count();
//dump('have '+count+' cards to delete\n');
    }
    return cards;
  }

  function forcePurgeDeleted(db) {
dump('  purge cards on deleted list\n');
    var count;
    if (!db.getDeletedCardList) { //since TB3a
      var count=db.deletedCardCount;
      var dList=db.deletedCardList.enumerate();
      while( dList.hasMoreElements() ) {
        var card = dList.getNext().QueryInterface(Components.interfaces.nsIAbCard);
//dump('set lmd on card '+card.primaryEmail+'\n');
        db.setCardValue(card, 'LastModifiedDate', '386d3570' , false);
        count++;
      }
      dList=null;
    } else {
      var countObj=new Object();
      var dListObj=new Object();
      db.getDeletedCardList(countObj, dListObj);
      if (countObj.value) {
        var dList=dListObj.value;
        var count=countObj.value; //dList.Count();
      } else count=0;
//dump(count+' elements on deleted list\n');
      for (var i=0; i<count; i++)
      {
        var card = dList.GetElementAt(i).QueryInterface(Components.interfaces.nsIAbCard);
//        386d3570 = 946681200 = 1.Jan.2000, must not be 0!!
//dump('set lmd on card '+card.primaryEmail+'\n');
        db.setCardValue(card, 'LastModifiedDate', '386d3570' , false);
//wow, with this function, i can set my own values!!
      }
      dListObj=null;
    }
//dump('lmd set on '+count+' cards, they should vanish soon\n');
  }

  //////////////////
  var curDB=this.removeListeners(dir);
  deleteLists(dir);
//dumpDir(dir, 'Lists Deleted:');

  try {
    var cards=collectCardsToDelete(dir, false);
dump('  start deleting cards\n');
    try {
      dir.deleteCards(cards);  // delete the cards from the to-be synced addressbook
    } catch(e) { //try Postbox
dump('Try the Postbox version :-(\n');
      cards=collectCardsToDelete(dir, true);
      dir.deleteCards(cards);  // delete the cards from the to-be synced addressbook
    }
dump('  cards deleted\n');
//dumpDir(dir, 'Cards deleted:');
    cards = null;
  } catch(e) {
    return 'rab_ve: clear addressbook: '+e;
  }


// The cards are not deleted immediately, they are put on a deletedCards Table
// This table can't be purge programmatically, they are automatically purged
// iff more than 50 Cards are in the table and only cards are purged that are
// older than 6 month :-(((
// Therefore I set the LastModifiedDate attribute on the deleted cards to an
// appropriate date (1.1.2000) so they will be deleted later on
  try  {
    forcePurgeDeleted(curDB);
  } catch(e) {
    return 'rab_ve: forcePurgeDeleted: '+e;
  }

  return '';
} // clearAddressBook

/*
 * Fill Addressbook from mab file
 */
function fillAddressBook(dir, file)
{
  function copyCards(db, ab, tab) {
dump('  copy cards\n');
    var tCards=db.enumerateCards(tab);
    if (tCards.hasMoreElements) { //since TB3a:    nsISimpleEnumerator
//dump('    have enumerated the cards\n');
      while(tCards.hasMoreElements()) {
        var tCard = tCards.getNext().QueryInterface(Components.interfaces.nsIAbCard);
        if (!tCard.isMailList) { // only non-maillists
          ab.dropCard(tCard, true); //true is necessary or tb crashes soon after
//dump('insert card '+tCard.primaryEmail+'\n');
//dump('.');
        }
      }
      tCards=null;
    } else {    //nsIEnumerator
      var goon=true;
      var n=0;
      // Loop over the cards
      try { tCards.first() } catch (e) { goon=false; }  //nsIEnumerator
      while (goon) {
        var tCard = tCards.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
        if (!tCard.isMailList) { // only non-maillists (die werden sonst normale cards)
//dump('insert card '+tCard.primaryEmail+'\n');
//dump('.');
          ab.dropCard(tCard, true);
        }
        try { tCards.next() } catch (e) { goon=false; }
      }
      tCards=null;
    }
//dump('\ndone\n');
//dumpDir(dir, 'Cards copied:');
  }

  function recreateMaillists(ab, tab, db) {
dump('  recreate maillists\n');
    var mailLists=tab.childNodes;
    try  {
      while (mailLists.hasMoreElements()) {
//dump('+');
        var mailList=mailLists.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
//dump(' recreate '+mailList.dirName+'\n');
        if (!mailList.addressLists.Count) { //since TB3a
          ab.deleteDirectory(mailList);
          ab.addMailList(mailList);
        } else {
          var nMailList = Components.classes["@mozilla.org/addressbook/directoryproperty;1"].
                              createInstance().QueryInterface(Components.interfaces.nsIAbDirectory);
          nMailList.isMailList = true;
          nMailList.dirName = mailList.dirName;
          nMailList.listNickName = mailList.listNickName;
          nMailList.description = mailList.description;
          var total = mailList.addressLists.Count();
          for (var pos=0; pos<total; pos++) {
            var cardproperty = mailList.addressLists.GetElementAt(pos);
            cardproperty = cardproperty.QueryInterface(Components.interfaces.nsIAbCard);
//            var newCardproperty = Components.classes["@mozilla.org/addressbook/cardproperty;1"].
//                createInstance().QueryInterface(Components.interfaces.nsIAbCard);
//            newCardproperty.primaryEmail = cardproperty.primaryEmail;
//            newCardproperty.displayName = cardproperty.displayName;
//            nMailList.addressLists.AppendElement(newCardproperty);
            nMailList.addressLists.AppendElement(cardproperty);
          }
          ab.addMailList(nMailList);
        }
      }
    } catch(e) {
dump('rab_ve: create cards for lists: '+e+'\n');
      return 'rab_ve: create cards for lists: '+e;
    }
    mailLists=null;
//dumpDir(dir, 'Recreated maillists:');
    return '';
  }

  var curDB=this.removeListeners(dir);

dump('  open the addressbook database file\n');
  try {
  // open the addressbook database file
    var db=Components.classes["@mozilla.org/addressbook/carddatabase;1"].
      getService(Components.interfaces.nsIAddrDatabase);
//TODO: falls readonly: kopieren und spter wieder lschen!!!
    var tempDB=db.open(file, true, false) // Throws error if file is readonly
      .QueryInterface(Components.interfaces.nsIAddrDatabase);
//dump('opened '+file.path+' -> '+tdb+'\n');
    //tdb.dbPath is undefined (TB2 only)
    // give me the maillists
      // must be moz-abmdbdirectory, not moz-abdirectory
  } catch(e) {  // might be NS_ERROR_FILE_ACCESS_DENIED
    return 'rab_ve: open mabfile: '+e;
  }

  var tempDir=Components.classes['@mozilla.org/rdf/resource-factory;1?name=moz-abmdbdirectory']
          .createInstance(Components.interfaces.nsIAbDirectory);
  try {
    copyCards(tempDB, dir, tempDir);
  } catch(e) {
    return 'rab_ve: copy cards: '+e;
  }

  try {
    var msg;
    if (this.haveABManager) { //since TB3a
      tempDB.getMailingListsFromDB(dir);
      msg=recreateMaillists(dir, dir, curDB);
    } else {
      tempDB.getMailingListsFromDB(tempDir);
      msg=recreateMaillists(dir, tempDir, curDB);
    }
    if (msg) this.promptService.alert(null, 'ERROR', msg);
  } catch(e) {
    this.promptService.alert(null, 'ERROR', 'rab_ve: recreate Maillists: '+e);
    return 'rab_ve: recreate Maillists: '+e;
  }
  tempDir=null;
  tempDB.forceClosed();  //!!!
  curDB.close(true);
  return '';
} // fillAddressBook

/*
 * Fill Addressbook from LDIF file
 */
function LDIFAddressBook(dir, file) {
  var selLocIsHome = true;
  var importService = Components.classes["@mozilla.org/import/import-service;1"].getService().
      QueryInterface(Components.interfaces.nsIImportService);
  var module = importService.GetModule('addressbook', 1);
  var observerService=Components.classes["@mozilla.org/observer-service;1"]
     .getService(Components.interfaces.nsIObserverService);

  var ldifimport = module.GetImportInterface( "addressbook").
      QueryInterface( Components.interfaces.nsIImportGeneric);
  if (ldifimport == null) {
dump('LDIF: No import interface\n');
    var str=Components.classes["@mozilla.org/supports-string;1"].createInstance().
      QueryInterface( Components.interfaces.nsISupportsString);
    str.data='No import interface';
    observerService.notifyObservers(str, "LDIFcomplete", "failed");
    return false;
  }

  ldifimport.SetData("addressLocation", file);

  var map = ldifimport.GetData( "fieldMap");
  if (map != null) {
dump('LDIF: Not a LDIF file!\n');
    var str=Components.classes["@mozilla.org/supports-string;1"].createInstance().
      QueryInterface( Components.interfaces.nsISupportsString);
    str.data='Not a LDIF file';
    observerService.notifyObservers(str, "LDIFcomplete", "failed");
    return false;
  }
  var abURIStr = Components.classes["@mozilla.org/supports-cstring;1"].createInstance().
      QueryInterface( Components.interfaces.nsISupportsCString);
  var dirProp =this.noDirProp?dir:dir.directoryProperties;
  abURIStr.data=dirProp.URI;
  ldifimport.SetData("addressDestination", abURIStr);
//else: created jedesmal ein neues AB mit Namen des LDIF Files

  if (ldifimport.WantsProgress()) {
//dump('wants Progress\n');
    var cont=LDIFAddressBookCont;
    if (ldifimport.BeginImport( cont.successStr, cont.errorStr, selLocIsHome)) {
//dump('start timer\n');
      cont.ldifimport=ldifimport;
      cont.observerService=observerService;
      cont.parent=this;
      var timer = Components.classes["@mozilla.org/timer;1"].
          createInstance(Components.interfaces.nsITimer);
      timer.initWithCallback(cont, 100, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
//dump('timer started\n');
    } else {
      observerService.notifyObservers(cont.errorStr, "LDIFcomplete", "failed");
    }
  } else {
//dump('no Progress\n');
    if (ldifimport.BeginImport( cont.successStr, cont.errorStr, selLocIsHome))
      observerService.notifyObservers(cont.successStr, "LDIFcomplete", "success");
    else
      observerService.notifyObservers(cont.errorStr, "LDIFcomplete", "failed");
  }
  return true;
}
let LDIFAddressBookCont = {
  successStr: Components.classes["@mozilla.org/supports-string;1"].createInstance().
      QueryInterface( Components.interfaces.nsISupportsString),
  errorStr: Components.classes["@mozilla.org/supports-string;1"].createInstance().
      QueryInterface( Components.interfaces.nsISupportsString),
  ldifimport: null,
  observerService: null,
  importSuccess: false,
  parent: null,

  notify: function(timer)
  {
//dump('timer called\n');
    let clear = true;
    let pcnt;

    if (this.ldifimport) {
//dump('continueImport: have interface\n');

      if (!this.ldifimport.ContinueImport()) {
//dump('continueImport: not continue\n');
        this.importSuccess = false;
        timer.cancel();
//dump('LDIF: Import failed: '+this.errorStr+'\n');
        this.observerService.notifyObservers(this.errorStr, "LDIFcomplete", "failed");
      }
      else if ((pcnt = this.ldifimport.GetProgress()) < 100) {
//dump('continueImport: GetProgress='+pcnt+'\n');
        clear = false;
      }
      else {
        timer.cancel();
        this.importSuccess = true;
//dump('LDIF: finished: '+this.successStr+'\n');
//       this.parent.promptService.alert(null, 'INFO', 'LDIF: Import finished: '+this.successStr);
        this.observerService.notifyObservers(this.successStr, "LDIFcomplete", "success");
      }
    }
    if (clear) {
      this.ldifimport = null;
    }
  }
}

/*
 * generate external filename for address book
 */
function externalFilename(dir) {
  var dirProp = this.noDirProp?dir:dir.directoryProperties;
  var externalFilename;
  var prefName = this.noDirProp?dirProp.dirPrefId:dirProp.prefName;
  try { externalFilename = this.mPrefBranch.getCharPref(prefName+'.filename'); }
  catch(e) {
    var uri = dirProp.URI;
    if (uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI)
      externalFilename = dir.dirName+'.mab';
    else
      externalFilename = '_tb_'+dirProp.fileName;
  }
//dump('get external filename '+dir.dirName+'->'+externalFilename+'\n');
  return externalFilename;
}
function setExternalFilename(dir, externalFilename) {
  var dirProp = this.noDirProp?dir:dir.directoryProperties;
  var prefName = this.noDirProp?dirProp.dirPrefId:dirProp.prefName;
  if (!externalFilename)
    this.mPrefBranch.clearUserPref(prefName+'.filename', externalFilename);
  else
    this.mPrefBranch.setCharPref(prefName+'.filename', externalFilename);
//dump('set external filename '+dir.dirName+'->'+externalFilename+'\n');
  return externalFilename;
}

